# coding: latin-1
"""
 <Von Stiften und Musen>
 Eine neue Portierung fr Python, entstanden im Rahmen meiner Diplomarbeit.

 Klasse Stift von SuM

 erste Vers: 14.01.2002
 Version...: 11.03.2003
 Status....: OK.
 Autor.....: i.linkweiler@gmx.de
"""

from bildschirm import *
from stift import *
from maus import *
from tastatur import *

class Anwendung:
  """
  Anwendung ist eine abstrakte Klasse als Basis fr alle weiteren Anwendungen.
  Sie besitzt bereits einen Bildschirm, Maus und Tastatur, die alle initialisiert sind.
  Bei der Realisierung von Anwendungen muss insbes. die Methode 'fuehreAus' berschrieben werden.
  Die Methoden '__init__' und 'gibFrei' mssen aufgerufen werden.
  '__init__' sollte nicht berschrieben werden. Wird eine eigene init-Methode gebraucht,
  sollte ein anderer Name wie z.B. 'start' verwendet und diese explizit aufgerufen werden.
  """
  
  def __init__(self):
    "Erzeugen und Initialisieren der verwendeten Objekte"
    self.bildschirm=Bildschirm()
    self.stift=Stift(self.bildschirm)
    self.maus=Maus(self.bildschirm)
    self.tastatur=Tastatur(self.bildschirm)
    
  def gibFrei(self):
    "Freigabe der verwendeten Objekte"
    self.tastatur.gibFrei()
    self.stift.gibFrei()
    self.maus.gibFrei()
    self.bildschirm.gibFrei()

  def hatBildschirm(self):
    "liefert den Bildschirm der Anwendung"
    return self.bildschirm

  def hatMaus(self):
    "liefert die Maus der Anwendung"
    return self.maus

  def hatTastatur(self):
    "liefert die Tastatur der Anwendung"
    return self.tastatur
   
  def fuehreAus(self):
    "Anfangs ohne Funktionalitt. Die Funktion ist per Vererbung zu definieren."
    pass

######################################################
# Testklasse
######################################################

class Test(Anwendung):
  "Beispiel / Test"
  def fuehreAus(self):
    "Aktionen der Anwendung"
    self.stift.bewegeBis(20,20)
    self.stift.runter()
    self.stift.bewegeBis(200,200)
    self.stift.schreibe("Ich bin eine Anwendung!")

def main():
  "Testcode: Anwendung erzeugen, starten und beenden."
  a=Test()
  a.fuehreAus()
  a.gibFrei()
  
    
if __name__ == '__main__': main()
