# coding: latin-1
"""
 Beispiel: Pong!
"""

from sum import *

# Definition der verwendeten Klassen Buntball, Tennisball und Spieler

class Buntball:
  # Der Buntball stellt einen farbigen bewegbaren Ball dar.

  def __init__(self):
    # Konstruktor:
    # Ein Ball hat einen Buntstift und eine Geschwindigkeit.
    self.stift=Buntstift()
    self.stift.setzeFuellMuster(1) 
    self.stift.bewegeBis(320,200)
    self.stift.dreheBis(30)
    self.tempo=1
  
  def gibFrei(self):
    # Auftrag:
    # Den Stift wieder freigeben
    self.stift.gibFrei()

  def setzeFarbe(self,farbe):
    # Auftrag:
    # Die Stiftfarbe das Balls wechseln
    self.stift.setzeFarbe(farbe)
    
  def zeichne(self):
    # Auftrag:
    # Einen Kreis an der aktuellen Stiftposition zeichnen
    self.stift.runter()
    self.stift.zeichneKreis(10)
    
  def bewege(self):
    # Auftrag:
    # Der Ball soll in der Richtung des Stiftes bewegt werden.   
    
    # mich selbst "wegradieren"
    self.stift.radiere()
    self.zeichne()

    # mich bewegen
    self.stift.bewegeUm(self.tempo)
      
    # Wenn ich den oberen oder unteren Rand erreiche, die Richtung ndern.
    # EInfallswinkel=Ausfallswinkel ==> Neue Richtung = 360-alte Richtung

    if self.stift.vPosition()<10:
      self.stift.dreheBis(360-self.stift.winkel())
    if self.stift.vPosition()>470:
      self.stift.dreheBis(360-self.stift.winkel())

    # mich neu zeichnen
    self.stift.normal()
    self.zeichne()




class Tennisball(Buntball):
  # Eine Erweiterung der Klasse Buntball
   
  def imSpielfeld(self):
    # Anfrage:
    # Liefert WAHR, wenn der Ball noch auf dem Spielfeld ist, also
    # Position seines Stiftes zwischen 0 und 640 liegt.
    return 0<self.stift.hPosition()<640

  def nachRechts(self):
    # Auftrag:
    # Wenn der Ball gerade nicht nach rechts fliegt (winkel zwischen 90 und 270),
    # dann drehe ihn nach rechts, d.h. winkel=180-winkel
    if 90 < self.stift.winkel() < 270:
      self.stift.dreheBis(180-self.stift.winkel())

  def nachLinks(self):
    # Auftrag:
    # Wenn der Ball gerade nicht nach links fliegt (winkel zwischen +-90 ),
    # dann drehe ihn nach links, d.h. winkel=180-winkel
    if self.stift.winkel()<90 or self.stift.winkel()>270:
      self.stift.dreheBis(180-self.stift.winkel())

  def schneller(self):
    self.tempo=self.tempo+0.5



class Spieler:
  def __init__(self):
    # Konstruktor:
    # Jeder Spieler hat einen Stift
    self.stift=Buntstift()  

  def bewegeBis(self,x,y):
    # Auftrag:
    # Der Spieler (bzw. sein Stift) wird nach x,y bewegt
    self.stift.bewegeBis(x,y)
    self.stift.normal()
    self.zeichne()

  def zeichne(self):
    # Auftrag:
    # Der Spieler wird an der aktuellen Stiftposition
    # durch ein 4x64 grosses Rechteck dargestellt
    self.stift.setzeFuellMuster(1)
    self.stift.zeichneRechteck(4,64)

  def bewegehoch(self):
    # Auftrag:
    # Der Spieler wird an der aktuellen Position ausradiert, 10 Schritte
    # nach oben bewegt (sofern er nicht oben ist) und wieder gezeichnet
    self.stift.radiere()
    self.zeichne()
    if self.stift.vPosition()>4:
      self.stift.bewegeBis(self.stift.hPosition(),self.stift.vPosition()-16)
    self.stift.normal()
    self.zeichne()

  def bewegerunter(self):
    # Auftrag:
    # Der Spieler wird an der aktuellen Position ausradiert, 10 Schritte
    # nach unten bewegt (sofern er nicht unten ist) und wieder gezeichnet
    self.stift.radiere()
    self.zeichne()
    if self.stift.vPosition()<440:
      self.stift.bewegeBis(self.stift.hPosition(),self.stift.vPosition()+16)
    self.stift.normal()
    self.zeichne()

  def trifft(self,ball):
    # Anfrage:
    # Liefere WAHR (bzw. 1), wenn der bergebene Ball den Schlger berhrt.
    # Das ist der Fall, wenn die Position des Spieler-Stifts +-14 horizontale und 0...64 Einheiten
    # vertikal mit der Position des Balls-Stifts bereinstimmt.
    
    treffer=0
    if self.stift.hPosition()-14 < ball.stift.hPosition() < self.stift.hPosition()+14:
      if self.stift.vPosition() < ball.stift.vPosition() < self.stift.vPosition()+64:
        treffer=1
    return treffer


##########################################################################
# DAS SPIEL-PROGRAMM
##########################################################################

# Zunchst erzeuge Instanzen von Bildschirm, Tastatur und Maus.
# Erzeuge einen "Tennisball" und 2 Spieler, und setze sie an die Anfangsposition

bildschirm=Bildschirm()
maus=Maus()
tastatur=Tastatur()

ball=Tennisball()
ball.setzeFarbe(GELB)

spieler1=Spieler()
spieler1.bewegeBis(20,200)
spieler2=Spieler()
spieler2.bewegeBis(600,200)

# Solange der Ball im Spielfeld ist, bewege den Ball.
# Wenn eine Taste (a,y bzw. k,m) gedrckt wurde, bewege den zugehrigen Spieler
# Wenn Spieler 1 den Ball trifft, schlage den Ball nach rechts.
# Wenn Spieler 2 den Ball trifft, schlage den Ball nach links.


while ball.imSpielfeld():
  ball.bewege()
  if tastatur.wurdeGedrueckt():
    z=tastatur.zeichen()
    if z=="a":
      spieler1.bewegehoch()
    if z=="y":
      spieler1.bewegerunter()
    if z=="k":
      spieler2.bewegehoch()
    if z=="m":
      spieler2.bewegerunter()
  
  if spieler1.trifft(ball):
    ball.nachRechts()
    ball.schneller()

  if spieler2.trifft(ball):
    ball.nachLinks()
    ball.schneller()
          
# Und Ende, die benutzen Objekte freigeben.
tastatur.gibFrei()
maus.gibFrei()
bildschirm.gibFrei()
