# coding: latin-1
"""
 <Von Stiften und Musen>
 Eine neue Portierung fr Python, entstanden im Rahmen meiner Diplomarbeit.

 Klasse Maus von SuM

 erste Vers: 04.02.2002
 Version...: 28.03.2003
 Status....: OK.
 Autor.....: i.linkweiler@gmx.de
"""

import sumwrapper

class Maus:
    """
    Die Maus realisiert die Mauseingabe des Computers. Diese ist gekennzeichnet durch
    Position und Tastenzustand.
    """
    
    def __init__(self,kennt_bildschirm=None):
      """
      Die Maus ist zur Nutzung aktiviert.
      Der zugehrige Bildschirm muss als Parameter bergeben werden.
      """     
      if kennt_bildschirm != None:
        self.bildschirm=kennt_bildschirm.bild
      else:
        self.bildschirm=sumwrapper.SCREEN
    
    def istGedrueckt (self):
      "Liefert 'wahr', wenn die Maustaste gedrckt ist."
      return self.bildschirm.mausstatus()
    
    def rechtsKlick(self):
      "Liefert 'wahr', wenn die rechte Maustaste gedrckt ist."
      return self.bildschirm.mausstatus()==3

    def doppelKlick(self):
      "Liefert 'wahr', wenn die rechte Maustaste gedrckt ist."
      return self.bildschirm.mausstatus()==3
    
    def hPosition(self):
      "Liefert die horizonate x-Position der Maus."
      return self.bildschirm.mauspos()[0]
      
    def vPosition(self):
      "Liefert die vertikale y-Position der Maus."
      return self.bildschirm.mauspos()[1]

    def position(self):
      "Alternative: Liefert die Mausposition als (x,y):Tupel"
      return self.bildschirm.mauspos()
          
    def gibFrei(self):
      "Gibt die Maus wieder frei."
      pass

from bildschirm import *
import time
def main():
    "Testprogramm."
    bild=Bildschirm()
    maus=Maus()

    while not maus.doppelKlick():
      print "Maus:",maus.hPosition(),maus.vPosition(),maus.istGedrueckt ()
      time.sleep(0.03)

    maus.gibFrei()
    bild.gibFrei()
        
# call the "main" function if running this script
if __name__ == '__main__': main()
