# coding: latin-1
import sumwrapper
import random
import math

class Sprite:
    """
    Diese neue Klasse Sprite stellt eine auf der Ausgabeflche frei bewegbare
    Figur (=eine kleine Grafik) dar. Sie eignet sich beispielsweise zur Darstellung von
    Spielcharakteren bei der Realisierung einfacher Computerspiele.
    """

    def __init__(self,bild,fenster=None):    
        "identisch zu laden"
        self.laden(bild,fenster)
    
    def laden(self,bilddatei,kennt_bildschirm=None):
        """
        Vorbereiten des Sprites: Das Bild (jpg/bmp) wird geladen und das Sprite
        ist vorbereitet.

        Eingabe:
        bilddatei:Dateiname als string
        fenster: zugehriger Bildschirm
        """

        if kennt_bildschirm != None:
          self.bildschirm=kennt_bildschirm.bild
        else:
          self.bildschirm=sumwrapper.SCREEN
      
        self.punching = 0
        self.pos=(0,0)
        self.move=(1,1)
        self.winkel=0
        
        self.id= self.bildschirm.add_sprite(bilddatei)
        #self.client.sendmsg(list2str(["newsprite",bilddatei]))

    def update(self):
        "Diese Methode kann berschrieben werden"
        pass

    def bewegeBis(self,x,y):
        "Bewege das Sprite an die Position x,y: int"
        self.setpos((x,y))

    def bewegeUm(self, pl):    	
        "Bewege das Sprite pl Einheiten in der aktuellen Richtung"

        w = self.winkel * math.pi/180
        x = self.pos[0] + pl * math.cos(w)
        y = self.pos[1] - pl * math.sin(w)
        self.setpos((x,y))

        
    def hPosition(self):
        "liefert die aktuelle x-Position"
        return self.pos[0]

    def vPosition(self):
        "liefert die aktuelle y-Position"
        return self.pos[1]

    def dreheBis(self,neuwinkel):
        "Drehe das Spritebild auf den angegebenen Drehwinkel. neuwinkel:int"
        self.winkel=neuwinkel % 360
        self.bildschirm.dreheBis(self.id,self.winkel)

    def dreheUm(self,neuwinkel):
        "Drehe das Spritebild um den angegebenen Drehwinkel. neuwinkel:int"
        self.winkel=(self.winkel+neuwinkel) % 360
        self.bildschirm.dreheBis(self.id,self.winkel)

  
    def loeschen(self):
        "Entferne das Sprite vom Bildschirm."
        self.bildschirm.loesche_sprite(self.id)
        self.kill()

    def gibFrei(self):
        "Entferne das Sprite vom Bildschirm."
        self.bildschirm.loesche_sprite(self.id)
        self.kill()


    def kollidiert(self,mit):
        return self.bildschirm.collision(self.id,mit.id)

    def setpos(self,pos):
        "intern: Setzte Sprite an Position pos: tupel"
        self.bildschirm.setpos(self.id,pos)
        self.pos=pos

from sum import *
def main():
    "Testprogramm."
    bild=Bildschirm()
    #bild.text("Hallo, Maustest!",(10,10),weiss)      
    maus=Maus()
    sp=Sprite("hand.bmp")

    while not maus.istGedrueckt ():
      pos=(maus.hPosition(),maus.vPosition())
      sp.setpos(pos)
    maus.gibFrei()
    bild.gibFrei()
        
# call the "main" function if running this script
if __name__ == '__main__': main()
